;; Copyright (c) 1996 Oscar Waddell
;;
;; See the file "Notice" for information on usage and redistribution
;; of this file, and for a DISCLAIMER OF ALL WARRANTIES.


(define-class (<sem> max . name) (<base>)
  (ivars (max (begin
                (unless (and (fixnum? max) (fxpositive? max))
                  (error '<sem> "invalid maximum value ~s" max))
                max))
         (n 0)
         (q (thread-make-msg-queue (if (pair? name) (car name) 'semaphore)))
	 (debug-flag #f)
	 )
  (inherited)
  (inheritable)
  (private)
  (protected)
  (public
    [set-debug-mode! (flag) (set! debug-flag flag)]
    [wait ()
     (thread-critical-section
       (when debug-flag (pb "semaphore wait n=~a~n" n))
       (set! n (fx+ n 1))
       (when (fx> n max) (thread-receive-msg q)))]
    [signal ()
       (when debug-flag (pb "semaphore signal n=~a~n" n))
       (unless (fxzero? n)
	 (thread-critical-section
	   (unless (fxzero? n)
	     (when (fx> n max) (thread-send-msg q 1))
	     (set! n (fx- n 1)))))]))
